package bk.CarController;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;
import bk.CarController.R;
import bk.CarController.Globals;
import android.app.Activity;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class CarController extends Activity implements SensorEventListener {
	
	SensorManager sensorManager = null;
	
	EditText IpAddress;
	EditText PortNum;
	TextView textIn;
	
	TextView X;
	TextView Y;
	TextView Z;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        
        sensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
        
        setContentView(R.layout.main);
        IpAddress = (EditText)findViewById(R.id.enteredIPaddress);
        PortNum = (EditText)findViewById(R.id.enteredPort);
        
        textIn = (TextView)findViewById(R.id.textin);
        
        X = (TextView)findViewById(R.id.X);
        Y = (TextView)findViewById(R.id.Y);
        Z = (TextView)findViewById(R.id.Z);
     
        //// Connect button listener////
        Button connectButton = (Button)findViewById(R.id.connectButton);
        connectButton.setOnClickListener(connectButtonOnClickListener);
      
        //// Disconnect button listener //// 
        Button DisconnectButton = (Button)findViewById(R.id.disconnectButton);
        DisconnectButton.setOnClickListener(DisconnectButtonOnClickListener);

        String AppTAG = bk.CarController.Globals.getTAG();  
        Log.d(AppTAG, "Loaded");
             
    }

    @Override
    public void onResume(){
    	super.onResume();
    	sensorManager.registerListener(this, sensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION),SensorManager.SENSOR_DELAY_GAME);
    }
    @Override
    public void onStop(){
    	super.onStop();
    	sensorManager.unregisterListener(this, sensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION));
    }
    
	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onSensorChanged(SensorEvent event) {
		// TODO Auto-generated method stub
		synchronized (this) {
		switch(event.sensor.getType()){
			case Sensor.TYPE_ORIENTATION: {
				X.setText("X: "+Float.toString(event.values[0]));
				Y.setText("Y: "+Float.toString(event.values[1]));
				float fy = event.values[1];
				int y = (int)fy;
				
				if( y > 20){
					
					//System.out.println("LEFT");
					bk.CarController.Globals.setLeft("L");
					//bk.CarControler.Globals.setLeft("L");
					bk.CarController.Globals.setRight("X");
				}
				if(y<-20){
					bk.CarController.Globals.setLeft("X");
					bk.CarController.Globals.setRight("R");
				}
				if((y<20)&&(y>-20)){
					bk.CarController.Globals.setLeft("X");
					bk.CarController.Globals.setRight("X");
				}
			
					
				Z.setText("Z: "+Float.toString(event.values[2]));
				
				float fz = event.values[2];
				int z = (int)fz;
				
				if( z > 60){
					//System.out.println("BACK");
					bk.CarController.Globals.setForward("X");
					bk.CarController.Globals.setBackward("B");
				}
				if(z<30){
					//System.out.println("FRWD");
					bk.CarController.Globals.setForward("F");
					bk.CarController.Globals.setBackward("X");
				}
				if((z>30)&&(z<60)){
					bk.CarController.Globals.setBackward("X");
					bk.CarController.Globals.setForward("X");
				}
				
				break;
			}
			case Sensor.TYPE_ACCELEROMETER: {
				break;
			}
		}
		}
	}
    
    GameLoop gameloop = new GameLoop();
    
    Button.OnClickListener connectButtonOnClickListener = new Button.OnClickListener(){
   @Override
   public void onClick(View arg0){

		   Log.d(bk.CarController.Globals.getTAG(),"Global Socket is Opening");
		   System.out.println(bk.CarController.Globals.getSocket().isConnected());
		   try{
			   
			   int port = Integer.parseInt(PortNum.getText().toString());
			   System.out.println(port);
			   Socket gsocket = new Socket(IpAddress.getText().toString(),Integer.parseInt(PortNum.getText().toString()));
			   bk.CarController.Globals.setSocket(gsocket);
   
		   }catch(Exception e){
			   Log.e(bk.CarController.Globals.getTAG(),e.toString());
		   }
		  
		   textIn.setText("Connected");
		   
		   bk.CarController.Globals.setSending(true);
		   gameloop.start();
		  
		   
   } };
   
	Button.OnClickListener DisconnectButtonOnClickListener = new Button.OnClickListener(){

		@Override
		public void onClick(View v) {
			// TODO Auto-generated method stub
				
			 Log.d(bk.CarController.Globals.getTAG(),"Global Socket is Closing");
		   	 System.out.println(bk.CarController.Globals.getSocket().isConnected());
		   		try {
		   			bk.CarController.Globals.getSocket().shutdownOutput();
		   			bk.CarController.Globals.getSocket().close();
		   		} catch (Exception e) {
		   			// TODO Auto-generated catch block
		   			Log.e(bk.CarController.Globals.getTAG(),e.toString());
		   		}
		
			textIn.setText("Disconnected");
			bk.CarController.Globals.setSending(false);
			gameloop.requestStop();
			
		}
	
	};


}
